const util = require("../../util");
const chalk = require("chalk");
const version = util.getPkg().version;
const v2OldOptions  = require('./v2OldOptions');
const usingOptions = require('./usingOptions')
const format = require('prettier').format

checkUcfConfigInfo = (options) => {
    let warn = options.join("、");
    if (options.length) {
        console.log(chalk.yellow(`以下配置项在 [version：${version}] 中已经废弃：`));
        console.log();
        console.log(chalk.yellow(`\t${warn}`));
        console.log();
        console.log(chalk.green(`-------------------------升级方案如下-------------------------------`));
        options.forEach(it=>{
            console.log(it)
            console.log((`--------------------------------------------------------`));
            console.log(chalk.yellow(`${it}:`));
            console.log((``));
            console.log(chalk.bgGreen(`升级前用法：（示例）`))
            console.log((``));
            console.log(`${v2OldOptions[it].old}`)
            console.log((``));
            console.log(chalk.bgGreen(`升级之后用法：（示例）`))
            console.log((``));
            console.log(`${v2OldOptions[it].new}`)
            console.log('');
        })
        console.log(chalk.green("具体修改方式请参考官方文档v2升级v3模块"));
        console.log();
       
        util.getOfficialUrl()
        console.log();
        console.log(`ucf-scripts内置升级脚本，可通过脚本初步升级`);
        console.log(chalk.yellow(`执行脚手架命令升级('脚本升级可能有部分错误，请手动修改！')`));
        console.log();
        console.log(chalk.green(`\tnpx ucf-scripts update`));
        console.log(chalk.green(`\t或者`));
        console.log(chalk.green(`\tucf-scripts update`));
        console.log();
        console.log(chalk.red("请及时清理废弃的API，精简配置，避免引起报错，影响使用！"));
    }
};

//检查当前版本
checkVersion = () => {
    const cfg = util.getCfg();
    let options = util.checkUcfConfigOptions(cfg);
    if(options.length){
        checkUcfConfigInfo(options);
    }else{
        console.log(chalk.green("检查通过。"));
    }
    return !options.length
};

//检查使用非法api，强制中断
checkUnusingOption = () =>{
    const cfg = util.getCfg();
    let usingList = Object.keys(usingOptions);
    let unusingapis = Object.keys(cfg).filter(it=>!usingList.includes(it))
    let apis = unusingapis.join('、');
    if(unusingapis.length){
        console.log(chalk.yellow(`以下配置项属于非法api，请及时精简ucf.config.js：`));
        console.log();
        console.log(chalk.yellow(`\t${apis}`));
    }
    return !unusingapis.length
}

module.exports = {
    name: "check",
    description: "这是检查命令",
    execute(isCheck, func, args) {
        if (isCheck) {
            console.log();
            console.log(chalk.green(`----------------------------------------------------`));
            console.log(chalk.green(`\t [UCF Version] : 🏅 ${version}`));
            console.log();
            console.log(chalk.green("ucf-scripts从v3.0版本以上配置升级，部分参数已经调整。"));
            console.log(chalk.green(`----------------------------------------------------`));
            console.log("开始执行检查逻辑！");
            checkUnusingOption() && checkVersion() && func(args);
            // checkVersion() && func(args);
        } else {
            func(args);
        }
    },
};
