module.exports = {
  hasHash:   {
    "upgradeTxt":"可通过配置项：hash 来做替代",
    "type":"string",
    "alterApi":"hash",
    old:
`hasHash:true`,
    new:
`hash:8`
  },
  open_source_map:   {
    "upgradeTxt":"",
    "type":"string",
    "alterApi":"devtool",
    "alterCode":"",
    old:
`open_source_map:false`,
    new:
`devtool:false`
  },
  css:   {
    "upgradeTxt":"可通过配置项：loaderConfig 来做替代",
    "type":"obejct",
    "alterApi":"loaderConfig",
    old:
`css:{
  modules: false,
  esModule: false,
}`,
    new:
`loaderConfig(defaultLoaderOptions){
  let options = defaultLoaderOptions.cssLoader.options
  defaultLoaderOptions.cssLoader.options = {
    ...options,
    modules: false,
    esModule: false,
  }
  return defaultLoaderOptions
}`
  },
  less:   {
    "upgradeTxt":"可通过配置项：loaderConfig 来做替代",
    "type":"object",
    "alterApi":"loaderConfig",
    old:
`less:{
  modules: false,
}`,
    new:
`loaderConfig(defaultLoaderOptions){
  let options = defaultLoaderOptions.lessLoader.options
  defaultLoaderOptions.lessLoader.options = {
    ...options,
    modules: false,
  }
  return defaultLoaderOptions
}`
  },
  postcss_plugins:   {
    "upgradeTxt":"可通过配置项：loaderConfig 来做替代",
    "type":"array",
    "alterApi":"loaderConfig",
    old:
`postcss_plugins:[require("postcss-flexbugs-fixes")]`,
    new:
`loaderConfig(defaultLoaderOptions) {
  let { postcssOptions } = defaultLoaderOptions.postcssLoader.options;
  const userOpts = [require("postcss-flexbugs-fixes")];
  postcssOptions.plugins = postcssOptions.plugins.concat(userOpts);
  defaultLoaderOptions.postcssLoader.options.postcssOptions = postcssOptions;
  return defaultLoaderOptions;
}
`
  },
  babel_include:   {
    "upgradeTxt":"可通过配置项：ruleConfig 来做替代",
    "type":"array",
    "alterApi":"ruleConfig",
    old:
`babel_include:[path.resolve(".", "ucf-apps"),]`,
    new:
`ruleConfig(defaultRulesOptions) {
  const { include: babelInclude } = defaultRulesOptions.babel;
  const userOpts = [path.resolve(".", "ucf-apps")];
  defaultRulesOptions.babel.include = babelInclude.concat(userOpts);
  return defaultRulesOptions;
}`
  },
  babel_presets:   {
    "upgradeTxt":"可通过配置项：loaderConfig 来做替代",
    "type":"array",
    "alterApi":"loaderConfig",
    old:
`babel_presets:["@babel/preset-typescript"];`,
    new:
`loaderConfig(defaultLoaderOptions) {
  const userOpts = ["@babel/preset-typescript"];
  const { presets } = defaultLoaderOptions.babelLoader.options;
  const newPresets = presets.concat(userOpts);
  defaultLoaderOptions.babelLoader.options.presets = newPresets;
  return defaultLoaderOptions;
}`
  },
  loader:   {
    "upgradeTxt":"可通过配置项：loaderConfig 来做替代",
    "type":"array",
    "alterApi":"loaderConfig",
    old:
`loaders: [
  {
      test: /\.ejs$/,
      use: [
          {
              loader: "ejs-compiled-loader",
              options: {
                  compileDebug: true,
              },
          },
      ],
  },
],`,
    new:
`//方式二
loaderConfig(defaultPluginOptions) {
    defaultPluginOptions.loaders = [
        {
            test: /\.ejs$/,
            use: [
                {
                    loader: "ejs-compiled-loader",
                    options: {
                        compileDebug: true,
                    },
                },
            ],
        },
    ]
   return defaultPluginOptions
},`
  },
  "devPlugins":   {
    "upgradeTxt":"",
    "type":"array",
    "alterApi":"pluginConfig",
    old:
`devPlugins: [
  new BundleAnalyzerPlugin()
],`,
    new:
`pluginConfig: {
  plugins : argv[0] === "build" ? 
          [new BPlugin()] :  [new BundleAnalyzerPlugin()]
},`
  },
  HtmlPluginConf:   {
    "upgradeTxt":"",
    "type":"object",
    "alterApi":"pluginConfig",
    old:
`HtmlPluginConf:{
  filename: "index.html",
}`,
    new:
`pluginConfig(defaultPluginOptions) {
  defaultPluginOptions.HtmlWebPackPlugin.filename = "index.html"
  return defaultPluginOptions;
},`
  },
  buildPlugins:   {
    "upgradeTxt":"",
    "type":"array",
    "alterApi":"pluginConfig",
    old:
`// 构建服务需要运行的插件
buildPlugins: [
  new BPlugin()
],`,
    new:
`pluginConfig: {
  plugins : argv[0] === "build" ? 
          [new BPlugin()] :  [new BundleAnalyzerPlugin()]
},`
  },
  babel_plugins:{
    "upgradeTxt":"",
    "type":"array",
    "alterApi":"loaderConfig",
    old:
`babel_plugins:[
  "@babel/plugin-proposal-optional-chaining"
],`,
    new:
`loaderConfig(defaultLoaderOptions) {
  let { options } = defaultLoaderOptions.babelLoader;
  const userOpts = ["@babel/plugin-proposal-optional-chaining"];
  options.plugins = options.plugins.concat(userOpts);
  defaultLoaderOptions.babelLoader.options.plugins = options.plugins;
  return defaultLoaderOptions;
}`
  },
  res_extra:{
    "upgradeTxt":"此配置项已经废弃，升级可不做关注",
    "type":"string",
    "alterApi":"",
    old:
`res_extra:true`,
    new:
`此配置项已经废弃，升级可不做关注`
  }
}