module.exports = (resolve, rootDir, jestConfig = {}) => {
  const config = {
    roots: ['<rootDir>/ucf-test/src'],
    collectCoverageFrom: ['src/**/*.{js,jsx,ts,tsx}', '!src/**/*.d.ts'],
    setupFiles: [
        resolve('test/jestsetup.js'),
    ],
    testMatch: [
      '<rootDir>/ucf-test/src/**/__tests__/**/*.{js,jsx,ts,tsx}',
      '<rootDir>/ucf-test/src/**/*.{spec,test}.{js,jsx,ts,tsx}',
    ],
    testEnvironment: 'jsdom',
    transform: {
      '^.+\\.(js|jsx|mjs|cjs|ts|tsx)$': resolve(
        'test/babelTransform.js'
      )
    },
    // transformIgnorePatterns: [
    //   '[/\\\\]node_modules[/\\\\].+\\.(js|jsx|mjs|cjs|ts|tsx)$'
    // ],
    moduleFileExtensions: [
        "js", "ts", "jsx", "tsx"
    ],
    // watchPlugins: [
    //   'jest-watch-typeahead/filename',
    //   'jest-watch-typeahead/testname',
    // ],
    resetMocks: true,
    ...jestConfig,
    moduleNameMapper: {
      ...(jestConfig.moduleNameMapper || {}),
      '^.+\\.(css|less)$': 'identity-obj-proxy',
    }

  };
  if (rootDir) {
    config.rootDir = rootDir;
  }
  return config;
};
